#!/bin/sh

# Configuration
# Le fichier sera nommé BASE_DIR/PREFIXEbasenameSUFFIXE
BASE_DIR=/var/backups/bdd-samba
PREFIXE=sauv_samba_
SUFFIXE=_$( date +%Y%m%d-%H%M ).tar.gz
DUREE_DE_VIE=100

# Vérifications initiales
if [ ! -d "$BASE_DIR" ]; then
	echo "ERREUR : répertoire de sauvegarde inexistant : $BASE_DIR ." >&2
	exit 1
fi

# Sauvegarde
cd /var/lib
tar -czf "$BASE_DIR/$PREFIXE"example.net"$SUFFIXE" samba

# Suppression des anciennes sauvegardes
if [ "$1" = "--delete-olds" ]; then
	find $BASE_DIR -name "$PREFIXE*" -mtime +$DUREE_DE_VIE -print0 | xargs -n 200 -r -0 rm -f
fi


